#ifndef H_ALGORITHM_H
#define H_ALGORITHM_H

#include <vector>
#include <string>
#include "utils.h"

template <class T> class HAlgorithm {
private:
	T* X;
	int n;
	int d;
	std::vector<std::string> measures;
	std::vector<TIMESTAMP> times;
public:
	T* getData();
	int getN();
	int getD();
	void setData(T* X,int n,int d);
	
	void addMeasure(std::string measure, TIMESTAMP time);
	int getMeasureCount();
	std::string getMeasureName(int i);
	TIMESTAMP getMeasureTime(int i);
	void clearStats();
	
	//HAlgorithm();
	/*virtual ~HAlgorithm();*/
	
	virtual void startExp()=0;
};

/*
template <class T> HAlgorithm<T>::HAlgorithm() {
}

template <class T> HAlgorithm<T>::~HAlgorithm() {
}*/

template <class T> void HAlgorithm<T>::addMeasure(std::string measure, TIMESTAMP time) {
	measures.push_back(measure);
	times.push_back(time);
}

template <class T> int HAlgorithm<T>::getMeasureCount() {
	return measures.size();
}

template <class T> std::string HAlgorithm<T>::getMeasureName(int i) {
	return measures[i];
}

template <class T> TIMESTAMP HAlgorithm<T>::getMeasureTime(int i) {
	return times[i];
}


template <class T> void HAlgorithm<T>::clearStats() {
	measures.clear();
	times.clear();
}

template <class T> T* HAlgorithm<T>::getData() {
	return X;
}

template <class T> int HAlgorithm<T>::getN() {
	return n;
}

template <class T> int HAlgorithm<T>::getD() {
	return d;
}

template <class T> void HAlgorithm<T>::setData(T* X,int n, int d) {
	this->X=X;
	this->n=n;
	this->d=d;
}



#endif