#include "lscvmulticuda.h"


float LSCVMultiCUDA::findGH(float *H) {
	return calcGH(this,getData(), H, getN(), getD());
}

float LSCVMultiCUDA::findGHForEst() {
	int d=getD();
	int n=getN();
	float * data=getData();
	float *cov=covarianceMatrix(data,d,n);
	float coeff=pow(4.0/(float)(d+2),1.0/(float)(d+4))*pow(n,-1.0/(float)(d+4));
	coeff=coeff*coeff;
	multMatrix(cov,d,d,coeff);
	float result=findGH(cov);
	delete []cov;
	return result;

}

void LSCVMultiCUDA::startExp() {
	findGHForEst();
}