#ifndef LSCVSSE_H
#define LSCVSSE_H

#include "halgorithm.h"
#include "simplemath.h"
#include "ssemath.h"
#include "sse_mathfun.h"
#include "matrices.h"
#include <stdio.h>

class LSCVSSE: public HAlgorithm<float> {
private:
	float step;
	static float kstar(float &v,int i,void *p);
	static __m128 kstarsse(__m128 &x,int i,void *v);
	float gh(float h, unsigned int n, unsigned int d, float C1, float C2,  float* exponents, float *temp);
	int threads;
	int cachesize;
public:
	void setStep(float step);
	float getStep();
	float findH();
	void setThreads(int threads);
	void setCachesize(int cachesize);
	virtual void startExp();
};


#endif