#include "pluginsse.h"


/*float PluginSSE::spk6c(float &x,int i,void *v) {
	float g1=((float*)v)[0];
	float xi=((float*)v)[1];
	
	return k6c((xi-x)/g1);
}

float PluginSSE::spk4c(float &x,int i,void *v) {
	float g2=((float*)v)[0];
	float xi=((float*)v)[1];
	
	return k4c((xi-x)/g2);
}*/

float PluginSSE::sqr(float &x,int i,void *v) {
	return x*x;
}

/*__m128 PluginSSE::spk6csse(__m128 &x,int i,void *v) {
	float lg1=((float*)v)[0];
	float lxi=((float*)v)[1];
	__m128 g1=_mm_set_ps(lg1,lg1,lg1,lg1);
	__m128 xi=_mm_set_ps(lxi,lxi,lxi,lxi);
	
	__m128 x2=_mm_div_ps(_mm_sub_ps(xi,x),g1);
	x2=_mm_mul_ps(x2,x2);
	__m128 res=_mm_add_ps(x2,_mm_set_ps(-15.0f,-15.0f,-15.0f,-15.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set_ps(45.0f,45.0f,45.0f,45.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set_ps(-15.0f,-15.0f,-15.0f,-15.0f));
	x2=_mm_mul_ps(x2,_mm_set_ps(-0.5f,-0.5f,-0.5f,-0.5f));
	res=_mm_mul_ps(res,_mm_mul_ps(_mm_set_ps(k_coeff,k_coeff,k_coeff,k_coeff),exp_ps(x2)));
	
	return res;
}

__m128 PluginSSE::spk4csse(__m128 &x,int i,void *v) {
	float lg2=((float*)v)[0];
	float lxi=((float*)v)[1];
	__m128 g2=_mm_set_ps(lg2,lg2,lg2,lg2);
	__m128 xi=_mm_set_ps(lxi,lxi,lxi,lxi);
	
	__m128 x2=_mm_div_ps(_mm_sub_ps(xi,x),g2);
	x2=_mm_mul_ps(x2,x2);
	__m128 res=_mm_add_ps(x2,_mm_set_ps(-6.0f,-6.0f,-6.0f,-6.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set_ps(3.0f,3.0f,3.0f,3.0f));
	x2=_mm_mul_ps(x2,_mm_set_ps(-0.5f,-0.5f,-0.5f,-0.5f));
	res=_mm_mul_ps(res,_mm_mul_ps(_mm_set_ps(k_coeff,k_coeff,k_coeff,k_coeff),exp_ps(x2)));
	
	return res;
}*/


__m128 PluginSSE::k6mm(__m128 x) {
	__m128 x2=_mm_mul_ps(x,x);
	__m128 res=_mm_add_ps(x2,_mm_set1_ps(-15.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set1_ps(45.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set1_ps(-15.0f));
	x2=_mm_mul_ps(x2,_mm_set1_ps(-0.5f));
	res=_mm_mul_ps(res,_mm_mul_ps(_mm_set1_ps(k_coeff),exp_ps(x2)));
	
	return res;
}

__m128 PluginSSE::k4mm(__m128 x) {
	__m128 x2=_mm_mul_ps(x,x);
	__m128 res=_mm_add_ps(x2,_mm_set1_ps(-6.0f));
	res=_mm_add_ps(_mm_mul_ps(x2,res),_mm_set1_ps(3.0f));
	x2=_mm_mul_ps(x2,_mm_set1_ps(-0.5f));
	res=_mm_mul_ps(res,_mm_mul_ps(_mm_set1_ps(k_coeff),exp_ps(x2)));
	
	return res;
}




__m128 PluginSSE::sqrsse(__m128 &x,int i,void *v) {
	return _mm_mul_ps(x,x);
}

void PluginSSE::setThreads(int threads) {
	this->threads=threads;
}

void PluginSSE::setCachesize(int cachesize) {
	this->cachesize=cachesize;
}

float PluginSSE::findH() {
	TIMESTAMP totalParallelizable=0;
	TIMESTAMP tempStart;
	TIMESTAMP start=getTimer();
	int n=getN();
	float *X=getData();
	
	tempStart=getTimer();
	float sumx=multiThreadedAggregateOMP<true>(X,n,threads,cachesize);
	float sumx2=multiThreadedAggregateOMPFun<PluginSSE::sqrsse,PluginSSE::sqr,true>(X,n,NULL,threads,cachesize);
	totalParallelizable+=getTimer()-tempStart;

	float var=estVar(n,sumx,sumx2);
	float stdDev=estStdDev(var);
	float _psi8=psi8(stdDev);
	float g1=f4(_psi8,n);
	
	/*
	float data[2];
	float *sumtemp=new float[n];
	
	
	
	data[0]=g1;
	
	
	for (int i=1;i<n;i++) {
		data[1]=X[i];
		sumtemp[i-1]=multiThreadedAggregateOMPFun<PluginSSE::spk6csse,PluginSSE::spk6c,true>(X,i,data,threads,cachesize);
	}
	
	
	float sumk6=multiThreadedAggregateOMP<false>(sumtemp,n-1,threads,cachesize);*/
	tempStart=getTimer();
	float sumk6=vecvecMatBigSSE1dFun<k6mm>(X,n,g1,threads);
	totalParallelizable+=getTimer()-tempStart;
	
	float _psi6=psi6(g1,n,sumk6);
	
	float g2=f2(_psi6,n);
	
	/*
	data[0]=g2;
	
	for (int i=1;i<n;i++) {
		data[1]=X[i];
		sumtemp[i-1]=multiThreadedAggregateOMPFun<PluginSSE::spk4csse,PluginSSE::spk4c,true>(X,i,data,threads,cachesize);
	}
	
	float sumk4=multiThreadedAggregateOMP<false>(sumtemp,n-1,threads,cachesize);
	
	delete []sumtemp;*/
	tempStart=getTimer();
	float sumk4=vecvecMatBigSSE1dFun<k4mm>(X,n,g2,threads);
	totalParallelizable+=getTimer()-tempStart;
	
	float _psi4=psi4(g2,n,sumk4);
	float h=hcoeff(_psi4,n);
	
	TIMESTAMP end=getTimer();
	
	addMeasure("PLUGIN_SSE_TOTAL",end-start);
	addMeasure("PLUGIN_SSE_PARALLELIZABLE",totalParallelizable);
	return h;
}


void PluginSSE::startExp() {
	/*__m128 x=_mm_set_ps(1.0f,2.0f,3.0f,4.0f);
	float d[]={2,3};
	x=spk4csse(x,0,d);
	float *t=(float*)&x;
	printf("%f %f %f %f \n",t[0],t[1],t[2],t[3]);
	float a[]={1.0f,2.0f,3.0f,4.0f};
	printf("%f %f %f %f \n",spk4c(a[0],0,d),spk4c(a[1],0,d),spk4c(a[2],0,d),spk4c(a[3],0,d));*/
	
	findH();
}

