#include "simplemath.h"

unsigned int intDivCeil(unsigned int value,unsigned int divisor) {
	return value/divisor+((value%divisor)!=0);
}


void vecvecMatBigSimple(float *X, float *m, int n, int d, float *out) {
	float temp[d];
	int p=0;
	for (int i=0;i<n;i++) {
		for (int j=0;j<i;j++) {
			for (int k=0;k<d;k++) {
				temp[k]=0;
				for (int l=0;l<d;l++) {
					temp[k]+=(X[i+n*l]-X[j+n*l])*m[k+d*l];
				}
			}
  
			float w2=0;
  
			for (int l=0;l<d;l++) {
				w2+=(X[i+n*l]-X[j+n*l])*temp[l];
			}
			out[p++]=w2;
		}
	}
}

unsigned int log2i(unsigned int v) {
	register unsigned int r; // result of log2(v) will go here
	register unsigned int shift;

	r =     (v > 0xFFFF) << 4; v >>= r;
	shift = (v > 0xFF  ) << 3; v >>= shift; r |= shift;
	shift = (v > 0xF   ) << 2; v >>= shift; r |= shift;
	shift = (v > 0x3   ) << 1; v >>= shift; r |= shift;
	r |= (v >> 1);
	
	return r;
}


unsigned int roundp2(unsigned int v) {
	v--;
	v |= v >> 1;
	v |= v >> 2;
	v |= v >> 4;
	v |= v >> 8;
	v |= v >> 16;
	v++;

	return v;
}


float* findExponents(unsigned int d, unsigned int n,float* data,float* invCov) {
	float *x=new float[d];
	float *xt=new float[d];
	float *o=new float[n*(n-1)/2];

	float *y=transposeMatrix(data,d,n);
	float *invCovTr=transposeMatrix(invCov,d,d);
	
	int p=0;
	for (int r=0;r<n;r++) {
		for (int c=r+1;c<n;c++) {
			for (int i=0;i<d;i++) {
				x[i]=y[r*d+i]-y[c*d+i];
			}

			for (int i=0;i<d;i++) {
				xt[i]=0;
				for (int j=0;j<d;j++) {
					xt[i]+=invCovTr[j+i*d]*x[j];
				}
				xt[i]*=x[i];
			}



			float sum=0;

			for (int i=0;i<d;i++) {
				sum+=xt[i];
			}

			o[p++]=sum;
		}
	}
	
	/*
	int p=0;
	for (int r=0;r<n;r++) {
		for (int c=r+1;c<n;c++) {
			for (int i=0;i<d;i++) {
				x[i]=data[r+i*n]-data[c+i*n];
			}

			for (int i=0;i<d;i++) {
				xt[i]=0;
				for (int j=0;j<d;j++) {
					xt[i]+=invCov[i+j*d]*x[j];
				}
				xt[i]*=x[i];
			}



			float sum=0;

			for (int i=0;i<d;i++) {
				sum+=xt[i];
			}

			o[p++]=sum;
		}
	}*/

	delete []x;
	delete []xt;
	delete []y;
	delete []invCovTr;
	return o;
}